!solve the acoustic vti nonlinear differential wave equation by rotated staggered fd for heterogeneous medium 

program acoustic_vti_modeling1
 use sep
 use init2d_mod
 use acoustic_vti_modeling_mod1
 
 implicit none
 
 real::dx,dz,dt,ox,oz,f,ox_shot,oz_shot,dx_shot,dz_shot,ox_rec,oz_rec,dx_rec,dz_rec,rate
 integer::nx,nz,nt,npad,nnx,nnz,nx_shot,nz_shot,nx_rec,nz_rec,ratio,nt_dat
 real,allocatable::dat(:,:,:,:,:),sou(:),v(:,:),eps(:,:),del(:,:)
 integer,allocatable::shot_loc(:,:,:),rec_loc(:,:,:)
 
 call sep_init()
 
 call init_spaces(nx,nz,nt,dx,dz,dt,ox,oz,npad,nnx,nnz)
 
 allocate(sou(nt))
 call init_sou(sou,f,dt)

 allocate(v(nnx,nnz),eps(nnx,nnz),del(nnx,nnz))
 call init_model(v,eps,del,nx,nz,npad)

 call init_shot(nx_shot,nz_shot,dx_shot,dz_shot,ox_shot,oz_shot)
 allocate(shot_loc(nx_shot,nz_shot,2))
 call init_shot_loc(shot_loc,nx_shot,nz_shot,dx_shot,dz_shot,ox_shot,oz_shot,npad,dx,dz,ox,oz)
  
 call init_rec(nx_rec,nz_rec,dx_rec,dz_rec,ox_rec,oz_rec)
 allocate(rec_loc(nx_rec,nz_rec,2))
 call init_rec_loc(rec_loc,nx_rec,nz_rec,dx_rec,dz_rec,ox_rec,oz_rec,npad,dx,dz,ox,oz)

 call from_param("rate",rate)
 ratio=nint(rate/dt)
 nt_dat=nint((nt-1.)/ratio+1.)
 allocate(dat(nx_shot,nz_shot,nx_rec,nz_rec,nt_dat)) 
 call acoustic_vti_modeling_kernel1(dat,shot_loc,rec_loc,v,eps,del,sou,nx,nz,nt,npad,dx,dz,dt,ratio)

 call sep_write(dat)

 call to_history("o1",ox_shot)
 call to_history("d1",dx_shot)
 call to_history("n1",nx_shot)
 call to_history("o2",oz_shot)
 call to_history("d2",dz_shot)
 call to_history("n2",nz_shot)  
 call to_history("o3",ox_rec)
 call to_history("d3",dx_rec)
 call to_history("n3",nx_rec)
 call to_history("o4",oz_rec)
 call to_history("d4",dz_rec)
 call to_history("n4",nz_rec)  
 call to_history("o5",0.)
 call to_history("d5",rate)
 call to_history("n5",nt_dat)
   
 call sep_close()
 deallocate(sou,v,eps,del,shot_loc,rec_loc,dat)
 
end program

 
