#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <omp.h>

#include "myio.h"
#include "mylib.h"
#include "wave.h"
#include "solvers.h"

void cg(float *pc11,float *pc13,float *pc33,const float *gc11,const float *gc13,const float *gc33,const float *c11,const float *c13,const float *c33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate){ 
 int nnx=nx+2*npad,nnz=nz+2*npad;
 
 float *dc11=new float[nnx*nnz]();
 float *dc13=new float[nnx*nnz]();
 float *dc33=new float[nnx*nnz]();
 
 float *ddc11=new float[nnx*nnz]();
 float *ddc13=new float[nnx*nnz]();
 float *ddc33=new float[nnx*nnz]();
 
 float *rc11_old=new float[nnx*nnz]();
 float *rc13_old=new float[nnx*nnz]();
 float *rc33_old=new float[nnx*nnz]();
 float *rc11_new=new float[nnx*nnz]();
 float *rc13_new=new float[nnx*nnz]();
 float *rc33_new=new float[nnx*nnz]();
 
 float *ppc11_old=new float[nnx*nnz]();
 float *ppc13_old=new float[nnx*nnz]();
 float *ppc33_old=new float[nnx*nnz]();
 float *ppc11_new=new float[nnx*nnz]();
 float *ppc13_new=new float[nnx*nnz]();
 float *ppc33_new=new float[nnx*nnz]();
 
 memset(pc11,0,nnx*nnz*sizeof(float));
 memset(pc13,0,nnx*nnz*sizeof(float));
 memset(pc33,0,nnx*nnz*sizeof(float));
 
 equate(rc11_old,gc11,nnx*nnz);
 equate(rc13_old,gc13,nnx*nnz);
 equate(rc33_old,gc33,nnx*nnz);
 
 mynegate(ppc11_old,rc11_old,nnx*nnz); 
 mynegate(ppc13_old,rc13_old,nnx*nnz); 
 mynegate(ppc33_old,rc33_old,nnx*nnz); 

 float *ppc11=new float[nnx*nnz*10]();
 float *ppc13=new float[nnx*nnz*10]();
 float *ppc33=new float[nnx*nnz*10]();
 
 float *res=new float[NITER_CG]();

 for(int iter=0;iter<NITER_CG;++iter){
  double temp1=dot_product(rc11_old,rc11_old,nnx*nnz)+dot_product(rc13_old,rc13_old,nnx*nnz)+dot_product(rc33_old,rc33_old,nnx*nnz);
  res[iter]=temp1; 
  fprintf(stderr,"iteration %d of CG\n",iter);
  std::cout<<"residual "<<temp1<<std::endl;
  
  hessian(pc11,pc13,pc33,d0,c11,c13,c33,ppc11_old,ppc13_old,ppc33_old,wavelet,sloc,ns,rloc,nr,taper,nx,nz,nt,npad,dx,dz,dt,rate);
  
  double temp2=dot_product(ppc11_old,pc11,nnx*nnz)+dot_product(ppc13_old,pc13,nnx*nnz)+dot_product(ppc33_old,pc33,nnx*nnz);
  
  float a=temp1/temp2;

  lin_comb(ddc11,1.,dc11,a,ppc11_old,nnx*nnz);
  lin_comb(ddc13,1.,dc13,a,ppc13_old,nnx*nnz);
  lin_comb(ddc33,1.,dc33,a,ppc33_old,nnx*nnz);
  
  lin_comb(rc11_new,1.,rc11_old,a,pc11,nnx*nnz);
  lin_comb(rc13_new,1.,rc13_old,a,pc13,nnx*nnz);
  lin_comb(rc33_new,1.,rc33_old,a,pc33,nnx*nnz);

  temp2=dot_product(rc11_new,rc11_new,nnx*nnz)+dot_product(rc13_new,rc13_new,nnx*nnz)+dot_product(rc33_new,rc33_new,nnx*nnz);
  float b=temp2/temp1;

  lin_comb(ppc11_new,-1.,rc11_new,b,ppc11_old,nnx*nnz); 
  lin_comb(ppc13_new,-1.,rc13_new,b,ppc13_old,nnx*nnz); 
  lin_comb(ppc33_new,-1.,rc33_new,b,ppc33_old,nnx*nnz); 

  float *pt;
  pt=dc11;dc11=ddc11;ddc11=pt;
  pt=dc13;dc13=ddc13;ddc13=pt;
  pt=dc33;dc33=ddc33;ddc33=pt;
  
  pt=rc11_new;rc11_new=rc11_old;rc11_old=pt;
  pt=rc13_new;rc13_new=rc13_old;rc13_old=pt;
  pt=rc33_new;rc33_new=rc33_old;rc33_old=pt;
  
  pt=ppc11_new;ppc11_new=ppc11_old;ppc11_old=pt;
  pt=ppc13_new;ppc13_new=ppc13_old;ppc13_old=pt;
  pt=ppc33_new;ppc33_new=ppc33_old;ppc33_old=pt;
 
  if(((iter+1)%100)==0){
   int k=iter/100;
   memcpy(ppc11+k*nnx*nnz,ddc11,nnx*nnz*sizeof(float));
   memcpy(ppc13+k*nnx*nnz,ddc13,nnx*nnz*sizeof(float));
   memcpy(ppc33+k*nnx*nnz,ddc33,nnx*nnz*sizeof(float));
  }
 }

 write("res",res,NITER_CG);
 to_header("res","n1",NITER_CG,"o1",0,"d1",1);

 write("pc11",ppc11,nnx*nnz*10);
 to_header("pc11","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("pc11","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("pc11","n3",10,"o3",0,"d3",1);
 write("pc13",ppc13,nnx*nnz*10);
 to_header("pc13","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("pc13","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("pc13","n3",10,"o3",0,"d3",1);
 write("pc33",ppc33,nnx*nnz*10);
 to_header("pc33","n1",nnx,"o1",-dx*npad,"d1",dx);
 to_header("pc33","n2",nnz,"o2",-dz*npad,"d2",dz);
 to_header("pc33","n3",10,"o3",0,"d3",1);
 
// memcpy(pc11,ddc11,nnx*nnz*sizeof(float));
// memcpy(pc13,ddc13,nnx*nnz*sizeof(float));
// memcpy(pc33,ddc33,nnx*nnz*sizeof(float));

 delete []ppc11;delete []ppc13;delete []ppc33; delete []res;
 delete []dc11;delete []dc13;delete []dc33;
 delete []ddc11;delete []ddc13;delete []ddc33;
 delete []rc11_old;delete []rc13_old;delete []rc33_old;
 delete []rc11_new;delete []rc13_new;delete []rc33_new;
 delete []ppc11_old;delete []ppc13_old;delete []ppc33_old;
 delete []ppc11_new;delete []ppc13_new;delete []ppc33_new;
 
 return;
}
