#ifndef KERNELS_H
#define KERNELS_H

#define BLOCK_DIM_X 16
#define BLOCK_DIM_Y 16
#define RADIUS 4

__constant__ float ca[RADIUS+1];

__global__ void injectD(float *tp,float *tq,const float *p,const float *q,float dx2,float dz2,float dt2);

__global__ void inject(float *p,float *q,const float *d0,const float *d1,float f,const int *rloc,int nr,int nnx,float dt2);

__global__ void inject(float *p,float *q,const float *d00,const float *d01,const float *d0,const float *d1,float f,const int *rloc,int nr,int nnx,float dt2);

__global__ void inject(float *p,float sval,int slocxz);

__global__ void record(float *d_p,const float *p,int nnx);

__global__ void inject(float *p,float *q,float sval,int slocxz,float dt2);

__global__ void inject(float *p,float *q,const float *fp,const float *fq,float dt2);

__global__ void inject(float *p,float *q,const float *dc11,const float *dc13,const float *dc33,const float *Dp,const float *Dq,float dt2);

__global__ void inject(float *p,float *q,const float *dc11,const float *dc13,const float *dc33,const float *Dp0,const float *Dq0,const float *Dp1,const float *Dq1,float f,float dt2);

__global__ void record(float *d,const float *p,const float *q,const int *rloc,int nr,int nnx);

__global__ void abc(float *p,float *q,const float *taper);

__global__ void D(float *tp,float *tq,const float *p,const float *q,float dx2,float dz2);

__global__ void C(float *tpp,float *tqq,const float *tp,const float *tq,
                  const float *c11,const float *c13,const float *c33);

__global__ void dC(float *tpp,float *tqq,const float *tp0,const float *tq0,const float *tp1,const float *tq1,float f,const float *dc11,const float *dc13,const float *dc33);

__global__ void forward(float *p0,float *q0,float *p1,float *q1,float *tpp,float *tqq,float dt2);

__global__ void backward(float *p1,float *q1,float *p0,float *q0,float *tpp,float *tqq,float dt2);

__global__ void imaging(float *dc11,float *dc13,float *dc33,const float *ap,const float *aq,const float *Dp,const float *Dq);

__global__ void imaging(float *dc11,float *dc13,float *dc33,const float *ap,const float *aq,const float *Dp0,const float *Dq0,const float *Dp1,const float *Dq1,float f);

__global__ void forwardCD(float *p0,float *q0,const float *p1,const float *q1,const float *c11,const float *c13,const float *c33,float dx2,float dz2,float dt2);

__global__ void backwardD(float *p1,float *q1,const float *p0,const float *q0,const float *tp,const float *tq,float dx2,float dz2,float dt2);

__global__ void forwardC(float *p0,float *q0,const float *p1,const float *q1,const float *tp,const float *tq,
                  const float *c11,const float *c13,const float *c33,float dt2);

void init_coeffs();

#endif
