#ifndef MYIO_H
#define MYIO_H

#include <cstdlib>
#include <iostream>
#include <string>
#include <fstream>

using namespace std;

extern int gargc;
extern char **gargv;

void myio_init(int,char **);

void myio_close();

string get_s(const string &);

string get_s(const string &,const string &);

template <class T> T &close_file(T &ios){
 ios.close();
 ios.clear();
 return ios;
}

template <class T> T &open_file(T &ios,const string &file,ios_base::openmode mode=ios_base::in){
 ios.close();
 ios.clear();
 ios.open(file.c_str(),mode);
 return ios;
}

template <typename T> int get_param(const string &sa,T &a){
 string s=get_s(sa);
 if(s==" "){
  string filename=get_s("par");
  s=get_s(filename,sa);
 }
 if(s!=" "){
  a=atof(s.c_str());
  return 1;
 }
 else{
  cout<<"cannot find parameter "<<sa<<endl;
  return 0;
 }
}

template <typename T1,typename T2,typename T3>
void get_param(const string &sa1,T1 &a1,const string &sa2,T2 &a2,const string &sa3,T3 &a3){
 get_param(sa1,a1);
 get_param(sa2,a2);
 get_param(sa3,a3);
 return;
}

template <typename T1,typename T2,typename T3> 
int to_header(const string &sh,const string &sa1,T1 a1,
                               const string &sa2,T2 a2,
                               const string &sa3,T3 a3){
 string filename=get_s(sh);
 if(filename==" "){
  cout<<"cannot find header "<<sh<<endl;
  return 0;
 }
 else{
  ofstream outfile;
  if(!open_file(outfile,filename,ofstream::app)){
   cout<<"cannot open header "<<sh<<endl;
   close_file(outfile);
   return 0;
  }
  else{
   outfile<<"\n"<<sa1<<"="<<a1<<"\n";
   if(sa2!=" ") outfile<<sa2<<"="<<a2<<"\n";
   if(sa3!=" ") outfile<<sa3<<"="<<a3<<"\n";
   close_file(outfile);
   return 1;
  }
 } 
}

template <typename T> int from_header(const string &sh,const string &sa,T &a){
 string filename=get_s(sh);
 if(filename==" "){
  cout<<"cannot find header "<<sh<<endl;
  return 0;
 }
 else{   
  string s=get_s(filename,sa);
  if(s!=" "){
   a=atof(s.c_str());
   return 1;
  } 
  else{
   cout<<"cannot find parameter "<<sa<<endl;
   return 0;
  }
 }
}

template <typename T1,typename T2,typename T3> 
void from_header(const string &sh,const string &sa1,T1 &a1,const string &sa2,T2 &a2,const string &sa3,T3 &a3){
 from_header(sh,sa1,a1);
 from_header(sh,sa2,a2);
 from_header(sh,sa3,a3);
 return;
}

template <typename T> 
void write(const string &s,const T *buff,size_t n,ios_base::openmode mode=ios_base::out){
 string hfile=get_s(s);
 if(hfile==" "){
  cout<<"cannot find header "<<s<<endl;
  return;
 }
 string path=get_s("/net/server/homes/sep/huyle/.datapath","datapath");
 if(path==" "){
  cout<<"cannot find datapath"<<endl;
  return;
 }
 string bfile=path+hfile+"@";
 ofstream out;
 if(!open_file(out,bfile,ofstream::binary|mode)){
  cout<<"cannot open binary file "<<bfile<<endl;
 }
 else{
  out.write((char*)buff,sizeof(T)*n);  
 }
 close_file(out);
 if(!open_file(out,hfile,ofstream::app)){
  cout<<"cannot open header "<<hfile<<endl;
 }
 else{
  if(get_s(hfile,"in")==" ") out<<"\n"<<"in="<<bfile<<"\n"<<"data_format=native_float"<<endl;
 }
 close_file(out);
 return;
}

template <typename T> void read(const string &s,T *buff,size_t n,size_t pos=0){
 string hfile=get_s(s);
 if(hfile==" "){
  cout<<"cannot find header "<<s<<endl;
  return;
 }
 string path=get_s("/net/server/homes/sep/huyle/.datapath","datapath");
 if(path==" "){
  cout<<"cannot find datapath"<<endl;
  return;
 }
 string bfile=path+hfile+"@";
 ifstream in;
 if(!open_file(in,bfile,ofstream::binary)){
  cout<<"cannot open binary file "<<bfile<<endl;
 }
 else{
  in.seekg(sizeof(T)*pos);
  in.read((char*)buff,sizeof(T)*n);
  close_file(in);
 }
 return;
}
                  
#endif
