#ifndef SOLVERS_H
#define SOLVERS_H

#define NITER_LS 5
#define NITER_ZOOM 10
#define NITER_CG 1000 

const float c1=1e-2;
const float c2=0.8;

void nlcg1(float *v,float *eps,float *del,float *f,float *g,int niter,float v0,float eps0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float line_search1(float *v,float *eps,float *del,float &f,float *ggv,float *ggeps,float *ggdel,float f0,const float *gv,const float *geps,const float *gdel,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *c11,float *c13,float *c33,float *gc11,float *gc13,float *gc33);

float zoom1(float *v,float *eps,float *del,float &f,float *ggv,float *ggeps,float *ggdel,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pv,const float *peps,const float *pdel,float v0,float eps0,float del0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate,float *c11,float *c13,float *c33,float *gc11,float *gc13,float *gc33);

void nlcg(float *c11,float *c13,float *c33,float *f,float *g,int niter,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void nlcg1(float *c11,float *c13,float *c33,float *f,float *g,int niter,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float line_search(float *c11,float *c13,float *c33,float &f,float *ggc11,float *gcc13,float *ggc33,float f0,const float *gc11,const float *gc13,const float *gc33,const float *pc11,const float *pc13,const float *pc33,float a0,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float zoom(float *c11,float *c13,float *c33,float &f,float *ggc11,float *ggc13,float *ggc33,float low,float high,float flow,float fhi,float glow,float ghi,float f0,float g0,const float *pc11,const float *pc13,const float *pc33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void cg(float *pc11,float *pc13,float *pc33,const float *gc11,const float *gc13,const float *gc33,const float *c11,const float *c13,const float *c33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void GNcg(float *pc11,float *pc13,float *pc33,const float *gc11,const float *gc13,const float *gc33,const float *c11,const float *c13,const float *c33,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void newton(float *c11,float *c13,float *c33,float *f,float *g,int niter,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void GN(float *c11,float *c13,float *c33,float *f,float *g,int niter,const float *d0,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

#endif
