#include <cstdlib>
#ifndef WAVE_H
#define WAVE_H

void GradCij2GradVEpsDel(float *gv,float *geps,float *gdel,const float *gc11,const float *gc13,const float *gc33,const float *v,const float *eps,const float *del,float v0,float eps0,float del0,size_t n);

void VEpsDel2Cij(float *c11,float *c13,float *c33,const float *v,const float *eps,const float *del,float v0,float eps0,float del0,size_t n);

void Cij2VEpsDel(float *v,float *eps,float *del,const float *c11,const float *c13,const float *c33,size_t n);

void check_stability(float *v,float *eps,float *del,float v0,float eps0,float del0,int nnx,int nnz,int npad);

void check_stability(float *c11,float *c13,float *c33,int nnx,int nnz,int npad);

void check_stability(const float *c11,const float *c13,const float *c33,float *dc11,float *dc13,float *dc33,size_t n);

void syntheticData0(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void syntheticData1(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void syntheticDataShot(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,int slocx,int slocz,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,int ratio);

void syntheticData(float *d,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void gradient0(float *gc11,float *gc13,float *gc33, const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void gradient1(float *gc11,float *gc13,float *gc33, const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void gradientShot(float *tgc11,float *tgc13,float *tgc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,int slocx,int slocz,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,int ratio);

void gradient(float *gc11,float *gc13,float *gc33, const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void hessian(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void GNhessian(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void hessian0(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void hessian1(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void hessian2(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

void hessian3(float *hc11,float *hc13,float *hc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *dc11,const float *dc13,const float *dc33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float objFunc(const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

float objFuncGradient(float *gc11,float *gc13,float *gc33,const float *d0,const float *c11,const float *c13,const float *c33,const float *wavelet,const int *sloc,int ns,const int *rloc,int nr,const float *taper,int nx,int nz,int nt,int npad,float dx,float dz,float dt,float rate);

#endif
